
#include <stdio.h>
#include <rabbit.h>
#include <../co_exec.h>

#define NUM_TASKS 2
#define STK_SIZE 4096

#ifdef FAR_STACKS
#define Stack NULL
#else
char Stack[STK_SIZE];
#endif

TASK tasks[NUM_TASKS];

int near Task1( int iParam );
char porta;

void main(void)
{
   WDT_DISABLE();    // Don't use watch dog
   ipset0();                    // Enable interrupts
   startTimer(10,NULL,1);
   puts("Startup.\n");
   outi(SPCR,0x84);
   #ifdef FAR_STACKS
   if (init_tasks( NUM_TASKS, STK_SIZE )) // number of tasks and size to allocate for all stacks
  {
       printf("init tasks failed!");
       return;
  }
  #else
   init_tasks(NUM_TASKS); // number of tasks
  #endif

   create_task( Task1, Stack, STK_SIZE, 0);
   puts("Task1 created\n");

   #asm
   .xxx:
        xor	a
		dec	a
		ioi	ld (PADR),a
   		lcall $task_switch
   		jr	.xxx
   	#endasm
   	yield;
}

int near Task1( int iParamnotused )
{
   printf( "Task1 Startup\n" );

   #asm
   .yyy:
        xor	a
		ioi ld (PADR),a
   		lcall $task_switch
   		jr	.yyy
   	#endasm
   	return 0;
}
